#include "ledDrive.h"

/*
    ledDriveΥޥ

              :    ̵뤵롣
    #ǻϤޤ     :    ȹ
    C               :    Хåե򥯥ꥢ롣
    L [n]           :    ХåեƤLED n롣
    X r ddd...d     :    Хåե rܤˡddd...dΥǡ񤭹
                         dϡ1ԥ1ʸ, R,G,O,.Τ줫ʸ
    S ddd...d       :    Хåե1ԥ뺸˥եȤǤⱦ 
			 ǡ񤭹
*/			 

void ledParseCommandFile(LedCont *cont,FILE *ifp)
{
  char line[1024];
  char *p;
  
  while(fgets(line, sizeof(line), ifp)!=NULL){
    for(p=line; isspace(*p);p++);
    if(*p == 0 || *p == '#') continue;

    if(*p == 'C')
      ledCmdClear(cont, p);
    else if(*p == 'L')
      ledCmdLight(cont, p);
    else if(*p == 'X')
      ledCmdDraw(cont, p);
    else if(*p == 'S')
      ledCmdShift(cont, p);
    else
      fprintf(stderr,"Undefined command: %s",p);
  }
}

void ledCmdClear(LedCont *cont,char *line)
{
  size_t size;
  LedBuf *buf = cont->buf;
  
  size = buf->width * buf->height;
  if(buf->data != NULL)
    memset(buf->data, 0, size);
}

void ledCmdLight(LedCont *cont,char *line)
{
  int i,count;

  if(sscanf(line+1,"%d", &count) < 1)
    count = 1;
  for(i=0;i<count;i++)
    ledDrive(cont, cont->buf);
}

/*
 *  X r ddd...d     :    Хåե rܤˡddd...dΥǡ񤭹
 *                       dϡ1ԥ1ʸ, R,G,O,.Τ줫ʸ
 */
void ledCmdDraw(LedCont *cont,char *line)
{
  LedBuf *buf = cont->buf;
  char *p;
  int x,y,v;
  
  y = strtol(line+1, &p, 10);
  if(p == line+1 || y < 0 || y >= buf->height)
    return;
  
  for(;isspace(*p);p++);
  v = 0;
  for(x=0;*p && x < buf->width;p++,x++){
    ledPixelSet(buf,x,y,*p);
  }
}

/*
 *  S ddd...d       :    Хåե1ԥ뺸˥եȤǤⱦ 
 *                       ǡ񤭹
 */
void ledCmdShift(LedCont *cont,char *line)
{
  LedBuf *buf = cont->buf;
  char *p;
  int x,y,v;

  for(p=line+1;isspace(*p);p++);
  
  for(y=0; *p && y<buf->height;y++,p++){
    for(x=0; x<buf->width-1;x++)
      buf->data[x+y*buf->width] = buf->data[x+1+y*buf->width];
    ledPixelSet(buf,x,y,*p);
  }
}

#define LedData(buf,x,y)  (buf)->data[(x)+(y)*(buf)->width]


void ledPixelSet(LedBuf *buf,int x,int y,int color)
{
  int off;
  int d;
  
  if(x < 0 || x >= buf->width ||
     y < 0 || y >= buf->height) return;

  off = y * buf->width + x;
  d = buf->data[off];
  
  switch(color){
  case 'r':
  case 'R':
    d  |=  buf->redMask;
    d  &= ~buf->greenMask;
    break;
  case 'g':
  case 'G':
    d &= ~buf->redMask;
    d |=  buf->greenMask;
    break;
  case 'o':
  case 'O':
    d |= buf->redMask;
    d |= buf->greenMask;
    break;
  default:
    d &= ~buf->redMask;
    d &= ~buf->greenMask;
    break;
  }
  buf->data[off] = d;
}
