#!/usr/bin/perl

use GD 1.20;
$im = new GD::Image(800,16);

$black = $im->colorAllocate(0,0,0);
$red    = $im->colorAllocate(255,0,0);
$green  = $im->colorAllocate(0,255,0);
$orange = $im->colorAllocate(255,255,0);
$margin = 32;
$tmpFile = ",tmp.led";
$font = "/usr/share/fonts/TrueType/watanabe-mincho.ttf";
-f $font || die "$font not found.\n";

@lines = <>;
while(1){
    foreach (@lines) {
	$str = $_;
	chop($str);
	$fs = 14;
	@b = $im->stringTTF($green,  $font, $fs, 0.0, 0, 14, $str);
	$x1 = $b[2];
	@b = $im->stringTTF($red,$font, $fs, 0.0, $x1+16, 14, "\$");
	$x1 = $b[2] + $margin;
	
	open(OFP,">$tmpFile") || die "open $tmpFile failed.\n";
	print OFP "C\n";
	print OFP "L 1\n";
	for($x=0;$x<$x1;$x++){
	    print OFP &ledShift($im,$x),"\n";
	    print OFP "L 1\n";
	}
	close(OFP);
	$im->filledRectangle(0,0,$x1,16,$black);
	system("./ledDrive -d 800 $tmpFile");
    }
}
exit(0);

sub ledShift {
    local($im, $x) = @_;
    local($y,$pixel,$ret,$r,$g,$b);
    $ret = "S ";
    for($y=0;$y<16;$y++){
	$pixel =  $im->getPixel($x,$y);
	($r,$g,$b) = $im->rgb($pixel);
	if($r > 0 && $g > 0){ $ret .= "O"; }
	elsif($r > 0)       { $ret .= "R"; }
	elsif($g > 0)       { $ret .= "G"; }
	else                { $ret .= "."; }
    }
    $ret;
}

